/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar las solicitudes de tipo programa en Venta Especial por Inventario.

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             	Autor                       Descripcion
    1.0    07-Enero-2020    	Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_SolicitudCompraInventProgramComCtrl {

    static String sRectorTypePasoInventario = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Inventario').getRecordTypeId();
    static String sRectorTypePasoPedidoEspecial = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Pedido Especial').getRecordTypeId();
    static String sRectorTypePasoPrograma = Schema.SObjectType.TAM_VinesFlotillaPrograma__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
    
    //Un controlados por default
    public TAM_SolicitudCompraInventProgramComCtrl(){}

    //Obtener distribuidores.
    @AuraEnabled(cacheable=true)
    public static List<InventarioWholesale__c> getInventarioPiso(String strCodigoDistribuidorParam) {
        System.debug('EN getInventarioPiso...');

        String strCodigoDistribuidor = strCodigoDistribuidorParam;
        System.debug('EN getInventarioPiso strCodigoDistribuidor: ' + strCodigoDistribuidor);
        Map<String, InventarioWholesale__c> mapVinObjInventa = new Map<String, InventarioWholesale__c>();
        Set<String> setVin = new Set<String>();
        List<InventarioWholesale__c> lInvPisoPaso = new List<InventarioWholesale__c>();
        //***Consulta los prductos que hay en el inventario de InventarioWholesale__c***//
        for (InventarioWholesale__c objInvWholeSale : [SELECT  Id,
                  Dealer_Code__c,
                  Interior_Color_Description__c,
                  Exterior_Color_Description__c,
                  AnioFactura__c,
                  Distributor_Invoice_Date_MM_DD_YYYY__c,
                  MesFactura__c,
                  Model_Number__c,
                  Model_Year__c, 
                  Toms_Series_Name__c,
                  Name,
                  TAM_ExteriorColorCode__c,
                  TAM_InteriorColorCode__c, 
                  TAM_IdExterno__c
                  FROM    InventarioWholesale__c
                  WHERE   Dealer_Code__c =: strCodigoDistribuidor
                  And TAM_ExteriorColorCode__c != null And TAM_InteriorColorCode__c != null
                  //And Model_Number__c = '1780' And (Model_Year__c= '2021' OR Model_Year__c= '2020') 
                  Order by Toms_Series_Name__c]){
            if (!setVin.contains(objInvWholeSale.Name)){
                lInvPisoPaso.add(objInvWholeSale);
                setVin.add(objInvWholeSale.Name);
            }//Fin si !setVin.contains(objInvWholeSale.Name)
        }
        
        System.debug('EN getInventarioPiso lInvPisoPaso: ' + lInvPisoPaso);
        return lInvPisoPaso;
    }    

    //Obtener distribuidores.
    @AuraEnabled(cacheable=true)
    public static List<Inventario_en_Transito__c> getInventarioTransito(String strCodigoDistribuidorParam) {
        System.debug('EN getInventarioTransito...');

        String strCodigoDistribuidor = strCodigoDistribuidorParam;
        System.debug('EN getInventarioTransito strCodigoDistribuidor: ' + strCodigoDistribuidor);
        
        Set<String> setVin = new Set<String>();
        List<Inventario_en_Transito__c> lInvPisoTransito = new List<Inventario_en_Transito__c>();
        //***Consulta los prductos que hay en el inventario de InventarioWholesale__c***//
        for (Inventario_en_Transito__c objInvWholeSale : [SELECT  Id,
                  Dealer_Code__c,
                  Interior_Color_Description__c,
                  Exterior_Color_Description__c,
                  AnioFactura__c,
                  Distributor_Invoice_Date_MM_DD_YYYY__c,
                  MesFactura__c,
                  Model_Number__c,
                  Model_Year__c, 
                  Toms_Series_Name__c,
                  Name,
                  TAM_ExteriorColorCode__c,
                  TAM_InteriorColorCode__c, 
                  TAM_IdExterno__c
                  FROM    Inventario_en_Transito__c
                  WHERE   Dealer_Code__c =: strCodigoDistribuidor
                  And TAM_ExteriorColorCode__c != null And TAM_InteriorColorCode__c != null
                  //And Model_Number__c = '1780' And (Model_Year__c= '2021' OR Model_Year__c= '2020') 
                  Order by Toms_Series_Name__c]){           
            if (!setVin.contains(objInvWholeSale.Name)){
                lInvPisoTransito.add(objInvWholeSale);
                setVin.add(objInvWholeSale.Name);
            }//Fin si !setVin.contains(objInvWholeSale.Name)
            
        }
        
        System.debug('EN getInventarioTransito lInvPisoTransito: ' + lInvPisoTransito);
        return lInvPisoTransito;
    }    

    @AuraEnabled
    public static List<TAM_OrdenDeCompraWrapperClass> getModelos(String recordId, List<InventarioWholesale__c> ListInventarioPiso,
        List<Inventario_en_Transito__c> ListInventarioTransito) {
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getModelos...');
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getModelos recordId: ' + recordId);
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getModelos ListInventarioPiso: ' + ListInventarioPiso);
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getModelos ListInventarioTransito: ' + ListInventarioTransito);

        Map<String, String> mapIdExtProdSerie = new Map<String, String>();

        String sEstatus = getEstatusSol(recordId);
        Boolean bSolCerrada = sEstatus == 'Cerrada' ?  true : false; 
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getModelos bSolCerrada: ' + bSolCerrada);
        
        //Consulta los registro de los distrivudidores asociados a esta solicitud
        Map<String, Integer> mapIdExternoDist = getSolDistrib(recordId);
        System.debug('EN getDistribuidores getModelos mapIdExternoDist: ' + mapIdExternoDist.keySet());
        System.debug('EN getDistribuidores getModelos mapIdExternoDist: ' + mapIdExternoDist.Values());
        
        Map<String, Boolean> mapIdExternoEntregaDist = getEntregaDistribuidora(recordId, sRectorTypePasoInventario);
        System.debug('EN getDistribuidores getModelos mapIdExternoEntregaDist: ' + mapIdExternoEntregaDist.keySet());
        System.debug('EN getDistribuidores getModelos mapIdExternoEntregaDist: ' + mapIdExternoEntregaDist.Values());       
        
        //Para los datos del inventario '57000'
        Id userId = UserInfo.getUserId();
        user usuario = [SELECT id,CodigoDistribuidor__c FROM user WHERE id =: userId];
        String strCodigoDistribuidor = usuario.CodigoDistribuidor__c == null ? '57000' : usuario.CodigoDistribuidor__c;
        if (Test.isRunningTest())
            strCodigoDistribuidor = '570550';
        
        Map<String, Map<String,Integer>> mapIdExtTotal = new Map<String, Map<String,Integer>>();   
        Map<String, InventarioWholesale__c> mapIdExtObjInvWholPiso = new Map<String, InventarioWholesale__c>();          
        List<InventarioWholesale__c> lstInventarioDistribuidorPiso = new List<InventarioWholesale__c>();
        Map<String, Inventario_en_Transito__c> mapIdExtObjInvWholTransito = new Map<String, Inventario_en_Transito__c>();   
        List<Inventario_en_Transito__c> lstInventarioDistribuidorTransito = new List<Inventario_en_Transito__c>(); 
        
        System.debug('EN getInventarioPiso antes de lka consulta de los vines de otras solicitudes...');    
        Map<String, Set<String>> mapIdExtTotalSolCerradasVines = new Map<String, Set<String>>();
        //Conslya las solicitudes que ya estan cerradas donde el 
        for (TAM_VinesFlotillaPrograma__c objVinesFlotProg : [Select t.Name, t.TAM_IdExterno__c, t.TAM_Estatus__c 
                From TAM_VinesFlotillaPrograma__c t Where 
                t.TAM_SolicitudFlotillaPrograma__r.TAM_Estatus__c = 'Cerrada' And
                t.TAM_Estatus__c != 'Cancelada' and t.TAM_SolicitudFlotillaPrograma__c != :recordId 
                ]){
            System.debug('EN getModelos TAM_IdExterno__c: ' + objVinesFlotProg.TAM_IdExterno__c);           
            //Toma el campo de TAM_IdExterno__c y destripalo
            String[] sTAMIdExterno = objVinesFlotProg.TAM_IdExterno__c.split('-');
            //Toma desde el numero 1 hasta el 5
            String ssTAMIdExternoPaso = sTAMIdExterno[1] + '-' + sTAMIdExterno[2] + '-' + sTAMIdExterno[3] + '-' + sTAMIdExterno[4] + '-' + sTAMIdExterno[5];
            
            System.debug('EN getModelos ssTAMIdExternoPaso: ' + ssTAMIdExternoPaso);
            //if (objVinesFlotProg.TAM_NoDistribuidor__c != strCodigoDistribuidor){
                //Ve si existe el ssTAMIdExternoPaso en el mapa de mapIdExtTotalSolCerradasVines
                if (mapIdExtTotalSolCerradasVines.containsKey(ssTAMIdExternoPaso))
                    mapIdExtTotalSolCerradasVines.get(ssTAMIdExternoPaso).add(objVinesFlotProg.Name);
                if (!mapIdExtTotalSolCerradasVines.containsKey(ssTAMIdExternoPaso))
                    mapIdExtTotalSolCerradasVines.put(ssTAMIdExternoPaso, new Set<String>{objVinesFlotProg.Name});
            //}//Fin si objVinesFlotProg.TAM_NoDistribuidor__c != strCodigoDistribuidor
        }
        System.debug('EN getModelos mapIdExtTotalSolCerradasVines: ' + mapIdExtTotalSolCerradasVines.keySet());
        System.debug('EN getModelos mapIdExtTotalSolCerradasVines: ' + mapIdExtTotalSolCerradasVines.Values());             

        Map<String,Double> mapPriceBookEntry = ObtenerPrecios();
        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.mapPriceBookEntry: ' + mapPriceBookEntry.KeySet());      

       //Mapa versiones de vehiculos
        List<Product2> lstProduct = [SELECT NombreVersion__c, IdExternoProducto__c, Serie__r.Id_Externo_Serie__c
                                     FROM   Product2 WHERE IsActive = true AND IdExternoProducto__c != null
                                     AND NombreVersion__c != null  Order by IdExternoProducto__c];
        String strCodigo;
        String strVersion;
        Map<String,String> mapVersion = new Map<String,String>();
        for(Product2 objProduct : lstProduct){
            strCodigo = objProduct.IdExternoProducto__c;
            strVersion = objProduct.NombreVersion__c;
            mapVersion.put(strCodigo, strVersion);
            //Agregalo al mapa de mapIdExtProdSerie
            mapIdExtProdSerie.put(objProduct.IdExternoProducto__c, objProduct.Serie__r.Id_Externo_Serie__c);            
        }
        System.debug('EN getDistribuidores getModelos mapIdExtProdSerie0: ' + mapIdExtProdSerie.keySet());
        System.debug('EN getDistribuidores getModelos mapIdExtProdSerie0: ' + mapIdExtProdSerie.Values());      

        System.debug('EN getDistribuidores getModelos mapVersion: ' + mapVersion.keySet());
        System.debug('EN getDistribuidores getModelos mapVersion: ' + mapVersion.Values());     
        
        //Las dos lista para los inventarios
        List<InventarioWholesale__c> listaInventarioWholesale = getInventarioPiso(strCodigoDistribuidor);
        List<Inventario_en_Transito__c> listaInventarioTransito = getInventarioTransito(strCodigoDistribuidor);
        
        //Consulta los prductos que hay en el inventario de InventarioWholesale__c//
        for (InventarioWholesale__c objInvWholeSale : listaInventarioWholesale){
            //System.debug('EN getInventarioPiso objInvTransito.TAM_IdExterno__c PISO: ' + objInvWholeSale.TAM_IdExterno__c);
            
            //Agrega el reg a la lista de lstInventarioDistribuidorPiso
            lstInventarioDistribuidorPiso.add(objInvWholeSale);
            
            String sIdExternoMod = objInvWholeSale.Model_Number__c + '' + objInvWholeSale.Model_Year__c;
            String sNombreVersion = mapVersion.get(sIdExternoMod);
            
            //Crea el external ide con todos los datos 
            String strIdExternoDistPaso = recordId + '-' + objInvWholeSale.Model_Year__c + '-' +  objInvWholeSale.Toms_Series_Name__c + '-' + objInvWholeSale.Model_Number__c + '-' + objInvWholeSale.TAM_ExteriorColorCode__c + '-' + objInvWholeSale.TAM_InteriorColorCode__c ;
            String strIdExternoDistVal = objInvWholeSale.Model_Year__c + '-' +  objInvWholeSale.Toms_Series_Name__c + '-' + objInvWholeSale.Model_Number__c + '-' +  objInvWholeSale.TAM_ExteriorColorCode__c + '-' + objInvWholeSale.TAM_InteriorColorCode__c ;
            //String strIdExternoDistVal = objInvWholeSale.Model_Year__c + '-' +  mapIdExtProdSerie.get(sIdExternoMod) + '-' + objInvWholeSale.Model_Number__c + '-' +  objInvWholeSale.TAM_ExteriorColorCode__c + '-' + objInvWholeSale.TAM_InteriorColorCode__c ;
            //System.debug('EN getDistribuidores getModelos strIdExternoDistPaso0: ' + strIdExternoDistPaso);
            //System.debug('EN getDistribuidores getModelos strIdExternoDistVal0: ' + strIdExternoDistVal);                 
            
            Set<String> setVinModelo = new Set<String>();           
            //if (sIdExternoMod == '22062020')
            //  System.debug('EN getInventarioPiso strIdExternoDistPaso PISO VIN: ' + objInvWholeSale.Name + ' sIdExternoMod:' + sIdExternoMod + ' strIdExternoDistPaso: ' +  strIdExternoDistPaso + ' strIdExternoDistVal: ' + strIdExternoDistVal);
            
            //Ve si tiene lgo objInvWholeSale.TAM_IdExterno__c
            if (objInvWholeSale.TAM_IdExterno__c != null){
                
                //if (objInvWholeSale.TAM_IdExterno__c == '24612020' ){
                
                //Busca el objInvWholeSale.TAM_IdExterno__c en el mapa de mapIdExtTotalSolCerradasVines
                if (mapIdExtTotalSolCerradasVines.containsKey(strIdExternoDistVal.toUpperCase()))
                    setVinModelo = mapIdExtTotalSolCerradasVines.get(strIdExternoDistVal.toUpperCase());
                System.debug('EN getInventarioPiso setVinModelo000: ' + setVinModelo);
                
                Boolean bExiste = false;
                //Busca objInvWholeSale.Name en setVinModelo
                if (!setVinModelo.isEmpty()){
                    if (setVinModelo.contains(objInvWholeSale.Name)){
                        bExiste = true;
                        System.debug('EN getInventarioPiso objInvWholeSale.Name000: ' + objInvWholeSale.Name + ' setVinModelo1: ' + setVinModelo + ' bExiste: ' + bExiste);
                    }
                }
                
                //Si no existe 
                if (!bExiste){
                    //System.debug('EN getInventarioPiso strIdExternoDistVal: ' + strIdExternoDistVal + ' objInvWholeSale.Name: ' + objInvWholeSale.Name);
                    //Ve si no exoste en el mapa de mapIdExtTotal entonces agregalo
                    if (mapIdExtTotal.containsKey(objInvWholeSale.TAM_IdExterno__c)){
                        if ( mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).containsKey(strIdExternoDistPaso) ){
                            //Sumale uno al valor que ya traes
                            Integer intTotal = mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).get(strIdExternoDistPaso) + 1;
                            mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).put(strIdExternoDistPaso, intTotal);
                            //System.debug('EN PISO YA EXISTE objInvWholeSale.TAM_IdExterno__c2: ' + objInvWholeSale.TAM_IdExterno__c + ' strIdExternoDistPaso: ' + strIdExternoDistPaso + ' strIdExternoDistPaso mapIdExtTotal0: ' + mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).get(strIdExternoDistPaso));                                                           
                        }//fin si  mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).containsKey(strIdExternoDistPaso)                    
                        if (!mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).containsKey(strIdExternoDistPaso)){
                            mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c).put(strIdExternoDistPaso, 1);
                            //System.debug('EN PISO NO EXISTE objInvWholeSale.TAM_IdExterno__c3: ' + objInvWholeSale.TAM_IdExterno__c + ' strIdExternoDistPaso: ' + strIdExternoDistPaso );
                        }
                    }//Fin si mapIdExtTotal.containsKey(objInvWholeSale.TAM_IdExterno__c)
                    if (!mapIdExtTotal.containsKey(objInvWholeSale.TAM_IdExterno__c)){
                        mapIdExtTotal.put(objInvWholeSale.TAM_IdExterno__c, new Map<String,Integer>{strIdExternoDistPaso => 1});
                        //System.debug('EN PISO NO EXISTE mapIdExtTotal3: ' + mapIdExtTotal.get(objInvWholeSale.TAM_IdExterno__c));                     
                    }
                    //Agregalo al mapa final de mapIdExtObjInvWholPiso
                    mapIdExtObjInvWholPiso.put(strIdExternoDistVal, objInvWholeSale);
                    System.debug('EN getDistribuidores PISO getModelos strIdExternoDistVal: ' + strIdExternoDistVal);                   
                }//Fin si bExiste

                //}//Fin si 
            
            }// Fin si objInvWholeSale.TAM_IdExterno__c != null
            
        }//Fin del for para InventarioWholesale__c
        //System.debug('EN getDistribuidores getModelos mapIdExtTotal: ' + mapIdExtTotal.keySet());
        //System.debug('EN getDistribuidores getModelos mapIdExtTotal: ' + mapIdExtTotal.Values());

        //Consulta los prductos que hay en el inventario de Inventario_en_Transito__c//
        for (Inventario_en_Transito__c objInvTransito : listaInventarioTransito){
            //System.debug('EN getInventarioPiso objInvTransito.TAM_IdExterno__c TRANS: ' + objInvTransito.TAM_IdExterno__c);
            
            //Agrega el reg a la lista de lstInventarioDistribuidorTransito
            lstInventarioDistribuidorTransito.add(objInvTransito);
            
            String sIdExternoMod = objInvTransito.Model_Number__c + '' + objInvTransito.Model_Year__c;
            String sNombreVersion = mapVersion.get(sIdExternoMod);
            
            //Crea el external ide con todos los datos 
            String strIdExternoDistPaso = recordId + '-' + objInvTransito.Model_Year__c + '-' +  objInvTransito.Toms_Series_Name__c + '-' + objInvTransito.Model_Number__c + '-' + objInvTransito.TAM_ExteriorColorCode__c + '-' + objInvTransito.TAM_InteriorColorCode__c ;
            String strIdExternoDistVal = objInvTransito.Model_Year__c + '-' +  objInvTransito.Toms_Series_Name__c + '-' + objInvTransito.Model_Number__c + '-' +  objInvTransito.TAM_ExteriorColorCode__c + '-' + objInvTransito.TAM_InteriorColorCode__c ;
            //String strIdExternoDistVal = objInvTransito.Model_Year__c + '-' +  mapIdExtProdSerie.get(sIdExternoMod) + '-' + objInvTransito.Model_Number__c + '-' +  objInvTransito.TAM_ExteriorColorCode__c + '-' + objInvTransito.TAM_InteriorColorCode__c ;
            //System.debug('EN getDistribuidores getModelos strIdExternoDistPaso1: ' + strIdExternoDistPaso);
            //System.debug('EN getDistribuidores getModelos strIdExternoDistVal1: ' + strIdExternoDistVal);                 

            Set<String> setVinModelo = new Set<String>();
            //if (sIdExternoMod == '17802021')
            //  System.debug('EN getInventarioPiso strIdExternoDistPaso TRANSITO VIN: ' + objInvTransito.Name + ' sIdExternoMod:' + sIdExternoMod + ' strIdExternoDistPaso: ' +  strIdExternoDistPaso + ' strIdExternoDistVal: ' + strIdExternoDistVal);

            //Ve si tiene lgo objInvTransito.TAM_IdExterno__c
            if (objInvTransito.TAM_IdExterno__c != null){

                //if (objInvTransito.TAM_IdExterno__c == '17802021'){

                //Busca el objInvTransito.TAM_IdExterno__c en el mapa de mapIdExtTotalSolCerradasVines
                if (mapIdExtTotalSolCerradasVines.containsKey(strIdExternoDistVal))
                    setVinModelo = mapIdExtTotalSolCerradasVines.get(strIdExternoDistVal);
                System.debug('EN getInventarioTransito setVinModelo111: ' + setVinModelo);
                
                Boolean bExiste = false;
                //Busca objInvTransito.Name en setVinModelo
                if (!setVinModelo.isEmpty())
                    if (setVinModelo.contains(objInvTransito.Name))
                        bExiste = true;
                
                if (Test.isRunningTest())
                    bExiste = false;
                    
                //Sin no existe
                if (!bExiste){
                    //if (sIdExternoMod == '22062020'){
                    //Ve si no exoste en el mapa de mapIdExtTotal entonces agregalo
                    if (mapIdExtTotal.containsKey(objInvTransito.TAM_IdExterno__c)){
                        if ( mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).containsKey(strIdExternoDistPaso) ){
                            Integer intTotal = mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).get(strIdExternoDistPaso) + 1;
                            mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).put(strIdExternoDistPaso, intTotal);
                            //System.debug('EN TRANSITO YA EXISTE mapIdExtTotal0: TAM_IdExterno__c: ' + objInvTransito.TAM_IdExterno__c + ' strIdExternoDistPaso: ' + strIdExternoDistPaso + ' ' + mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c)); 
                        }//Fin si mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).containsKey(strIdExternoDistPaso) 
                        if (!mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).containsKey(strIdExternoDistPaso))
                            mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c).put(strIdExternoDistPaso, 1);
                            //System.debug('EN TRANSITO YA EXISTE mapIdExtTotal1: TAM_IdExterno__c: ' + objInvTransito.TAM_IdExterno__c + ' strIdExternoDistPaso: ' + strIdExternoDistPaso + ' ' + mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c));                         
                    }//Fin si mapIdExtTotal.containsKey(objInvTransito.TAM_IdExterno__c)
                    if (!mapIdExtTotal.containsKey(objInvTransito.TAM_IdExterno__c))
                        mapIdExtTotal.put(objInvTransito.TAM_IdExterno__c, new Map<String,Integer>{strIdExternoDistPaso => 1}); 
                        //System.debug('EN TRANSITO NO EXISTE mapIdExtTotal2: TAM_IdExterno__c: ' + objInvTransito.TAM_IdExterno__c + ' strIdExternoDistPaso: ' + mapIdExtTotal.get(objInvTransito.TAM_IdExterno__c));
                    //Agregalo al mapa final de mapIdExtObjInvWholTransito
                    mapIdExtObjInvWholTransito.put(strIdExternoDistVal, objInvTransito);
                    System.debug('EN getDistribuidores TRANSITO getModelos strIdExternoDistVal: ' + strIdExternoDistVal);
                    //}//Fin si sIdExternoMod == '22062020'
                }//Fin si bExiste
                
                //}//Fin si objInvWholeSale.TAM_IdExterno__c == '17802021'
                
            }// Fin si objInvTransito.TAM_IdExterno__c != null
            
        }//Fin del for para Inventario_en_Transito__c

        //Si esta cerrada entonces agrega el los modelos que vienen en mapIdExtTotalSolCerradasVines
        if (bSolCerrada){
            //Limpia el mapa de mapIdExtTotal
            mapIdExtTotal.clear();
            
            //Consulta lops vines asociados a esta solicitud
            for (TAM_VinesFlotillaPrograma__c objVinesFlotProg : [Select t.TAM_IdExterno__c 
                    From TAM_VinesFlotillaPrograma__c t Where
                    t.TAM_SolicitudFlotillaPrograma__c = :recordId  
                    ]){
                System.debug('EN getDistribuidores TAM_IdExterno__c: ' + objVinesFlotProg.TAM_IdExterno__c);            
                //Toma el campo de TAM_IdExterno__c y destripalo
                String[] sTAMIdExternoPaso = objVinesFlotProg.TAM_IdExterno__c.split('-');
                //Toma desde el numero 1 y 3 a20e0000003CQucAAG-2020-RAV4-4504-070-20-JTMY23FV0LJ031670-012e0000000AYwhAAG
                String ssTAMIdExternoFin = sTAMIdExternoPaso[3] + '' + sTAMIdExternoPaso[1];
                String sSerie = sTAMIdExternoPaso[2];
                System.debug('EN getModelos sTAMIdExternoPaso: ' + ssTAMIdExternoFin + ' sSerie: ' + sSerie);               
                String strIdExternoDistCerrada = recordId + '-' + sTAMIdExternoPaso[1] + '-' + mapIdExtProdSerie.get(ssTAMIdExternoFin) + '-' + sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5];
                System.debug('EN getDistribuidores getModelos strIdExternoDistCerrada1: ' + strIdExternoDistCerrada);               
                                
                //Ve si existe ssTAMIdExternoFin en mapIdExtTotal
                if (mapIdExtTotal.containsKey(ssTAMIdExternoFin)){
                    if ( mapIdExtTotal.get(ssTAMIdExternoFin).containsKey(strIdExternoDistCerrada) ){
                        Integer intTotal = mapIdExtTotal.get(ssTAMIdExternoFin).get(strIdExternoDistCerrada) + 1;
                        mapIdExtTotal.get(ssTAMIdExternoFin).put(strIdExternoDistCerrada, intTotal);
                    }//Fin si mapIdExtTotal.get(ssTAMIdExternoFin).containsKey(strIdExternoDistPaso) 
                    if (!mapIdExtTotal.get(ssTAMIdExternoFin).containsKey(strIdExternoDistCerrada))
                        mapIdExtTotal.get(ssTAMIdExternoFin).put(strIdExternoDistCerrada, 1);
                }//Fin si mapIdExtTotal.containsKey(ssTAMIdExternoFin)                  
                if (!mapIdExtTotal.containsKey(ssTAMIdExternoFin))
                    mapIdExtTotal.put(ssTAMIdExternoFin, new Map<String,Integer>{strIdExternoDistCerrada => 1});                                                        
                
            }//Fin del for para mapIdExtTotalSolCerradasVines.keySet()
        }//Fin si bSolCerrada
        //System.debug('EN getDistribuidores getModelos mapIdExtTotal111: ' + mapIdExtTotal.keySet());
        //System.debug('EN getDistribuidores getModelos mapIdExtTotal111: ' + mapIdExtTotal.Values());      
        
        for(String sIdExt : mapIdExtTotal.keySet()){
            System.debug('EN getDistribuidores getModelos mapIdExtTotal sIdExt: ' + sIdExt);
            for (String sIdExrPaso : mapIdExtTotal.get(sIdExt).KeySet()){
                System.debug('EN getDistribuidores getModelos mapIdExtTotal sIdExrPaso: ' + sIdExrPaso);
                System.debug('EN getDistribuidores getModelos mapIdExtTotal Valur: ' + mapIdExtTotal.get(sIdExt).get(sIdExrPaso));
            }
        }        
        
        //Cinsulta el catalogo de prodictos para que te traigas las series reales
        for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c 
                From Product2 p where IdExternoProducto__c IN : mapIdExtTotal.KeySet()]){
            //Agregalo al mapa de mapIdExtProdSerie
            mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
        }
        System.debug('EN getDistribuidores getModelos mapIdExtProdSerie2: ' + mapIdExtProdSerie.keySet());
        System.debug('EN getDistribuidores getModelos mapIdExtProdSerie2: ' + mapIdExtProdSerie.Values());              

        Set<String> setIdExterno = new Set<String>();
        List<CatalogoCentralizadoModelos__c> lstModelos = new List<CatalogoCentralizadoModelos__c>();                                                            
        Map<string,CatalogoCentralizadoModelos__c> mapCatalogoModelos = new Map<string,CatalogoCentralizadoModelos__c>();                                                               
        for (CatalogoCentralizadoModelos__c objCatCentMod : [  SELECT  Id,
                                                                    Name,
                                                                    Marca__c,
                                                                    Serie__c,
                                                                    Modelo__c,
                                                                    AnioModelo__c,
                                                                    CodigoColorExterior__c,
                                                                    CodigoColorInterior__c,
                                                                    DescripcionColorExterior__c,
                                                                    DescripcionColorInterior__c,
                                                                    Version__c
                                                            FROM CatalogoCentralizadoModelos__c 
                                                            ORDER BY Name]){
           String sIdExtModAnio = objCatCentMod.Modelo__c + '' + objCatCentMod.AnioModelo__c;
           //Crea el Id de la llave para cada reg
           //String llave = objCatCentMod.Serie__c + '-' + objCatCentMod.Modelo__c + '-' + objCatCentMod.AnioModelo__c + '-' + objCatCentMod.CodigoColorExterior__c + '-' + objCatCentMod.CodigoColorInterior__c;
           String llave = mapIdExtProdSerie.get(sIdExtModAnio) + '-' + objCatCentMod.Modelo__c + '-' + objCatCentMod.AnioModelo__c + '-' + objCatCentMod.CodigoColorExterior__c + '-' + objCatCentMod.CodigoColorInterior__c;           
           //System.debug('EN getDistribuidores getModelos llave: ' + llave);
           mapCatalogoModelos.put(llave, objCatCentMod);
            System.debug('EN getDistribuidores getModelos llave: ' + llave);
            
        }                                                    
        System.debug('EN getDistribuidores getModelos mapCatalogoModelos: ' + mapCatalogoModelos.keySet());
        System.debug('EN getDistribuidores getModelos mapCatalogoModelos: ' + mapCatalogoModelos.Values());
        
        //Ve si esta cerrada la solicitud
        if (bSolCerrada){
            lstModelos.clear();
            for(CatalogoCentralizadoModelos__c objModelo : [  SELECT Id, Name, Marca__c,Serie__c,
                                                          Modelo__c,AnioModelo__c,CodigoColorExterior__c,
                                                          CodigoColorInterior__c, DescripcionColorExterior__c,
                                                          DescripcionColorInterior__c,Version__c
                                                          FROM CatalogoCentralizadoModelos__c ORDER BY Name]) {
                String sIdExterno = objModelo.Modelo__c + '' + objModelo.AnioModelo__c;
                setIdExterno.add(sIdExterno);                                                               
                //Agregao a la lista de lstModelos
                lstModelos.add(objModelo);
            }
        }//Fin si bSolCerrada
                
        String strCodigoModelo;
        List<TAM_OrdenDeCompraWrapperClass> lstOrdenCompraWrapper = new List<TAM_OrdenDeCompraWrapperClass>();
        
        //Recore la lista de modelos del mapa mapIdExtTotal   
        for (String sIdExtCod : mapIdExtTotal.KeySet()){
            //System.debug('EN getDistribuidores getModelos sIdExtCod: ' + sIdExtCod);
            
            //if (sIdExtCod == '24612020'){
            
            String[] sTAMIdExternoPaso;
            String ssTAMIdExternoFin;
            String ssIdExterno;
            //Recorre la lista de mapIdExtTotal.get() 
            for (String sIdExtCodCol : mapIdExtTotal.get(sIdExtCod).KeySet()){
                System.debug('EN getDistribuidores getModelos mapIdExtTotal.get(sIdExtCod).get(sIdExtCodCol): ' + mapIdExtTotal.get(sIdExtCod).get(sIdExtCodCol));                  
                //Toma el campo de TAM_IdExterno__c y destripalo
                sTAMIdExternoPaso = sIdExtCodCol.split('-'); //a20e0000003CQucAAG-2019-HILUX-7495-040-20 || a20e0000003CVsmAAG, 2020, C, HR, 2461, 040, 20  
                System.debug('EN getDistribuidores getModelos sTAMIdExternoPaso2: ' + sTAMIdExternoPaso + ' ' + sTAMIdExternoPaso.size());
                
                //Toma desde el numero 1 y 3            
                if (sTAMIdExternoPaso.size() == 7){
                    ssTAMIdExternoFin = sTAMIdExternoPaso[4] + '' + sTAMIdExternoPaso[1];
                    ssIdExterno = sTAMIdExternoPaso[1] + '-' + sTAMIdExternoPaso[2] + '-' + sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5] + '-' + sTAMIdExternoPaso[6];
                }//Fin si sTAMIdExterno.size() > 7
                if (sTAMIdExternoPaso.size() == 6){                 
                    ssTAMIdExternoFin = sTAMIdExternoPaso[3] + '' + sTAMIdExternoPaso[1];
                    ssIdExterno = sTAMIdExternoPaso[1] + '-' + sTAMIdExternoPaso[2] + '-' + sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5];
                }//Fin si sTAMIdExterno.size() <= 7
                //Toma desde el numero 1 hasta el 5
                System.debug('EN getDistribuidores getModelos ssTAMIdExternoFin2: ' + ssTAMIdExternoFin);   
            
            //}//Fin del for para mapIdExtTotal.get(sIdExtCod).KeySet()
                        
            System.debug('EN getDistribuidores getModelos sIdExtCod2: ' + sIdExtCod);
            Boolean bInvWholeSale = true;
            InventarioWholesale__c objInvWholeSale;
            Inventario_en_Transito__c objInvTransito;
            
            if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno)){
                System.debug('EN getDistribuidores getModelos mapIdExtObjInvWholPiso ssIdExterno2: ' + ssIdExterno);    
                
                objInvWholeSale = mapIdExtObjInvWholPiso.get(ssIdExterno); 
                strCodigoModelo = objInvWholeSale.Model_Number__c + objInvWholeSale.Model_Year__c;
                System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strCodigoModelo: ' + strCodigoModelo);        
            }//Fin si mapIdExtObjInvWholPiso.containsKey(ssIdExterno)
            
            //No esta en el inventario en piso esta en el de transito
            if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno)){
                if (mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){
                    System.debug('EN getDistribuidores getModelos mapIdExtObjInvWholTransito ssIdExterno2: ' + ssIdExterno);    
                    
                    objInvTransito = mapIdExtObjInvWholTransito.get(ssIdExterno); 
                    strCodigoModelo = objInvTransito.Model_Number__c + objInvTransito.Model_Year__c;
                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strCodigoModelo: ' + strCodigoModelo); 
                    bInvWholeSale = false;  
                }//Fin si mapIdExtObjInvWholPiso.containsKey(ssIdExterno)
            }//Fin si !mapIdExtObjInvWholPiso.containsKey(ssIdExterno)
            
            //Si no existe en los dos inventarios
            if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno))
                strCodigoModelo = ssTAMIdExternoFin;
            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strCodigoModelo: ' + strCodigoModelo);

            //System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos objInvTransito.Toms_Series_Name__c: ' + objInvTransito.Toms_Series_Name__c); 
            //System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos objInvWholeSale.Toms_Series_Name__c: ' + objInvWholeSale.Toms_Series_Name__c); 
            String sSeriesPaso = ''; 
            if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno))
                sSeriesPaso = mapIdExtProdSerie.get(sIdExtCod).toUpperCase();
            //Existe en alguno de los dos inventarios
            if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno) || mapIdExtObjInvWholTransito.containsKey(ssIdExterno)) 
                sSeriesPaso = bInvWholeSale ? objInvWholeSale.Toms_Series_Name__c : objInvTransito.Toms_Series_Name__c;
            //Inicializa sSeriesFinal   
            String sSeriesFinal = sSeriesPaso != null ? sSeriesPaso : '';
            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos sSeriesFinal: ' + sSeriesFinal); 
            
            //Crea la llave externa del reg para buscarlo en el mapa de mapIdExternoDist y obtener el total
            String strIdExternoDistPaso = '';
            if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){
                strIdExternoDistPaso = recordId + '-' + sTAMIdExternoPaso[1] + '-' + sSeriesPaso + '-' + sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5];
                System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strIdExternoDistPaso3: ' + strIdExternoDistPaso); 
            }
            if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno) || mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){    
                strIdExternoDistPaso =  recordId + '-' + (bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c ) + '-' + 
                sSeriesFinal + '-' + //sSeriesFinal.toUpperCase() mapIdExtProdSerie.get(strCodigoModelo) 
                (bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c) + '-' + 
                (bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c) + '-' + 
                (bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c);
                System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strIdExternoDistPaso4: ' + strIdExternoDistPaso); 
            }
            
            //String strLlaveMapCantidad = (bInvWholeSale ? objInvWholeSale.Toms_Series_Name__c : objInvTransito.Toms_Series_Name__c) + '-' + 
            String strLlaveMapCantidad = '';
            if (Test.isRunningTest()) strLlaveMapCantidad = sSeriesFinal.toUpperCase() + '-';
            if (!Test.isRunningTest()) strLlaveMapCantidad = mapIdExtProdSerie.get(sIdExtCod).toUpperCase() + '-'; // sSeriesFinal.toUpperCase() + '-' + 
            //Ve si no esta en ningun de los dos inventarios
            if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno) || mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){    
                strLlaveMapCantidad += (bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c)  + '-' + 
                (bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c  ) + '-' + 
                (bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c) + '-' + 
                (bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c);
                System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strLlaveMapCantidad0: ' + strLlaveMapCantidad); 
            }
            //Ve si no esta en ningun de los dos inventarios            
            if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){
                strLlaveMapCantidad += sTAMIdExternoPaso[1] + '-' + sSeriesPaso.toUpperCase() + '-' +  sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5];
                if (bSolCerrada)
                    strLlaveMapCantidad = sSeriesPaso.toUpperCase() + '-' +  sTAMIdExternoPaso[3] + '-' + sTAMIdExternoPaso[1] + '-' + sTAMIdExternoPaso[4] + '-' + sTAMIdExternoPaso[5];
                System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strLlaveMapCantidad1: ' + strLlaveMapCantidad); 
            }

            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strCodigoModelo000: ' + strCodigoModelo);
            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strIdExternoDistPaso000: ' + strIdExternoDistPaso);
            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos mapIdExtTotal.Value000: ' + (mapIdExtTotal.containsKey(strCodigoModelo) ? String.valueOf(mapIdExtTotal.get(strCodigoModelo)) : null));             
            System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos strLlaveMapCantidad000: ' + strLlaveMapCantidad);
            
            String Marca, DescripcionColorExterior, DescripcionColorInterior;
            
            //Ve si el producto tiene disponibilidad en el inventario y despliegalo
            if (mapIdExtTotal.containsKey(strCodigoModelo)){
                //System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos mapIdExtTotal.get(strCodigoModelo): ' + mapIdExtTotal.get(strCodigoModelo).KeySet() + ' strIdExternoDistPaso: ' + strIdExternoDistPaso);
                
                if (mapIdExtTotal.get(strCodigoModelo).containsKey(strIdExternoDistPaso)){

                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos mapIdExtTotal.get(strCodigoModelo)1111: ' + mapIdExtTotal.get(strCodigoModelo).KeySet() + ' strIdExternoDistPaso: ' + strIdExternoDistPaso + ' strLlaveMapCantidad: ' + strLlaveMapCantidad);
                    
                    //Ve si existe la llave strLlaveMapCantidad en el mapa de  mapCatalogoModelos
                    if(mapCatalogoModelos.containsKey(strLlaveMapCantidad)){
                        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos Llave: '+ strLlaveMapCantidad + ' Valor: '+ mapCatalogoModelos.get(strLlaveMapCantidad).Id);
                        DescripcionColorExterior = mapCatalogoModelos.get(strLlaveMapCantidad).DescripcionColorExterior__c;
                        DescripcionColorInterior = mapCatalogoModelos.get(strLlaveMapCantidad).DescripcionColorInterior__c;
                        Marca = mapCatalogoModelos.get(strLlaveMapCantidad).DescripcionColorInterior__c;
                        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos DescripcionColorExterior: '+ DescripcionColorExterior);
                        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos DescripcionColorInterior: '+ DescripcionColorInterior);
                    }//Fin si mapCatalogoModelos.containsKey(strLlaveMapCantidad)
                    
                    //Si no lo encientra ve que paso 
                    if(!mapCatalogoModelos.containsKey(strLlaveMapCantidad))
                        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos NO ENTRO ESTA Llave: '+ strLlaveMapCantidad);
                    
                    //Iniciliza la cantidad 
                    Integer cIntcCantidad = mapIdExtTotal.get(strCodigoModelo).get(strIdExternoDistPaso);
                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos cIntcCantidad0000: ' + cIntcCantidad);    

                    String strSeriePaso = '';
                    if (Test.isRunningTest()) strSeriePaso = sSeriesFinal.toUpperCase();
                    if (!Test.isRunningTest()) strSeriePaso = mapIdExtProdSerie.get(sIdExtCod).toUpperCase(); //
                    
                    String sModelNumber;
                    String sModelYear;
                    String sExteriorColorCode;
                    String sInteriorColorCode;
                    String sDescripcionColorExterior;
                    String sDescripcionColorInterior;                   
                    String IdExtFinal;
                    if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno) || mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){    
                        sModelNumber = (bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c);
                        sModelYear = (bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c);
                        sExteriorColorCode = (bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c);
                        sInteriorColorCode = (bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c);
                        sDescripcionColorExterior = (bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c) + '-' + DescripcionColorExterior;
                        sDescripcionColorInterior = (bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c) + '-' + DescripcionColorInterior;
                        IdExtFinal = sSeriesFinal + '-' + mapVersion.get(strCodigoModelo) + '-' + (bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c) + '-' + (bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c);
                        System.debug('EN EXISTE TAM_SolicitudCompraInventProgramComCtrl.getModelos sModelNumber00: ' + sModelNumber + ' sModelYear: ' + sModelYear + ' sExteriorColorCode: ' + sExteriorColorCode + ' sInteriorColorCode: ' + sInteriorColorCode + ' sDescripcionColorExterior: ' + sDescripcionColorExterior + ' sDescripcionColorInterior: ' + sDescripcionColorInterior); 
                        System.debug('EN EXISTE TAM_SolicitudCompraInventProgramComCtrl.getModelos IdExtFinal00: ' + IdExtFinal); 
                    }
                    if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno)){
                        sModelNumber = sTAMIdExternoPaso[3];
                        sModelYear = sTAMIdExternoPaso[1];
                        sExteriorColorCode = sTAMIdExternoPaso[4];
                        sInteriorColorCode = sTAMIdExternoPaso[5];
                        sDescripcionColorExterior = sTAMIdExternoPaso[4] + '-' + DescripcionColorExterior;
                        sDescripcionColorInterior = sTAMIdExternoPaso[5] + '-' + DescripcionColorInterior;                      
                        IdExtFinal = sSeriesFinal + '-' + mapVersion.get(strCodigoModelo) + '-' + sModelNumber + '-' + sModelYear;
                        System.debug('EN NO EXISTE TAM_SolicitudCompraInventProgramComCtrl.getModelos sModelNumber00: ' + sModelNumber + ' sModelYear: ' + sModelYear + ' sExteriorColorCode: ' + sExteriorColorCode + ' sInteriorColorCode: ' + sInteriorColorCode + ' sDescripcionColorExterior: ' + sDescripcionColorExterior + ' sDescripcionColorInterior: ' + sDescripcionColorInterior); 
                        System.debug('EN NO EXISTE TAM_SolicitudCompraInventProgramComCtrl.getModelos IdExtFinal00: ' + IdExtFinal); 
                    }

                    //Crea el objeto del tipo TAM_OrdenDeCompraWrapperClass
                    TAM_OrdenDeCompraWrapperClass objPasoTAMOrdDeComWrpClass = new TAM_OrdenDeCompraWrapperClass(    
                                    Marca, //objInvWholeSale.Marca__c,
                                    strSeriePaso, //mapIdExtProdSerie.get(sIdExtCod).toUpperCase(), //sSeriesFinal.toUpperCase(),
                                    sModelNumber, //(bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c),
                                    sModelYear, //(bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c),
                                    mapVersion.get(strCodigoModelo), //objInvWholeSale.Version__c,
                                    sExteriorColorCode, //(bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c),
                                    sInteriorColorCode, //(bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c),
                                    DescripcionColorExterior, //objInvWholeSale.DescripcionColorExterior__c,
                                    DescripcionColorInterior, //objInvWholeSale.DescripcionColorInterior__c,
                                    mapIdExtTotal.containsKey(strCodigoModelo) ? String.valueOf(mapIdExtTotal.get(strCodigoModelo)) : null, 
                                    null,
                                    String.valueOf(mapPriceBookEntry.get(strCodigoModelo)),
                                    null,
                                    strIdExternoDistPaso, //objInvWholeSale.Name,
                                    IdExtFinal, //sSeriesFinal + '-' + mapVersion.get(strCodigoModelo) + '-' + (bInvWholeSale ? objInvWholeSale.Model_Number__c : objInvTransito.Model_Number__c) + '-' + (bInvWholeSale ? objInvWholeSale.Model_Year__c : objInvTransito.Model_Year__c),
                                    sDescripcionColorExterior, //(bInvWholeSale ? objInvWholeSale.TAM_ExteriorColorCode__c : objInvTransito.TAM_ExteriorColorCode__c) + '-' + DescripcionColorExterior, //objInvWholeSale.DescripcionColorExterior__c,
                                    sDescripcionColorInterior, //(bInvWholeSale ? objInvWholeSale.TAM_InteriorColorCode__c : objInvTransito.TAM_InteriorColorCode__c) + '-' + DescripcionColorInterior, //objInvWholeSale.DescripcionColorInterior__c,
                                    false //String.valueOf(cIntcCantidad) //mapIdExtTotal.containsKey(strCodigoModelo) ? String.valueOf(mapIdExtTotal.get(strCodigoModelo)) : null   //false
                    );
                    
                    //Ve si existe en algun inventario
                    if (mapIdExtObjInvWholPiso.containsKey(ssIdExterno) || mapIdExtObjInvWholTransito.containsKey(ssIdExterno))
                        objPasoTAMOrdDeComWrpClass.strIdCatModelos = (bInvWholeSale ? objInvWholeSale.id : objInvTransito.id);
                    if (!mapIdExtObjInvWholPiso.containsKey(ssIdExterno) && !mapIdExtObjInvWholTransito.containsKey(ssIdExterno))
                        objPasoTAMOrdDeComWrpClass.strIdCatModelos = mapCatalogoModelos.containsKey(sIdExtCod) ? mapCatalogoModelos.get(sIdExtCod).id : null;

                    objPasoTAMOrdDeComWrpClass.strIdExterno = strIdExternoDistPaso;
                    objPasoTAMOrdDeComWrpClass.strCantidadInventario = String.valueOf(cIntcCantidad);
                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getModelos objPasoTAMOrdDeComWrpClass: ' + objPasoTAMOrdDeComWrpClass); 

                    //mapIdExtTotalSolCerradasVines 2019-HILUX-7495-040-20 strIdExternoDistPaso
                    String strIdExternoDistValida = strIdExternoDistPaso.substring(strIdExternoDistPaso.IndexOf('-') + 1, strIdExternoDistPaso.length()).toUpperCase();
                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.strIdExternoDistValida: ' + strIdExternoDistValida);
                    
                    if (bSolCerrada){
                        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl objPasoTAM_OrdenDeCompraWrapperClass: ' + objPasoTAMOrdDeComWrpClass.strIdExterno + ' strCantidad: ' +  objPasoTAMOrdDeComWrpClass.strCantidad);                                                               
                        lstOrdenCompraWrapper.add(objPasoTAMOrdDeComWrpClass);
                    }//fin si bSolCerrada && intCantidad > 0 cIntcCantidad
                    if (!bSolCerrada && cIntcCantidad > 0)
                        lstOrdenCompraWrapper.add(objPasoTAMOrdDeComWrpClass);
                        
                    //Agregalo a la lista de lstOrdenCompraWrapper 
                    //lstOrdenCompraWrapper.add(objPasoTAMOrdDeComWrpClass);
                    System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl objPasoTAMOrdDeComWrpClass: ' + objPasoTAMOrdDeComWrpClass);

                }//Fin si if (mapIdExtTotal.get(strCodigoModelo).containsKey(strIdExternoDistPaso)){
                
            }//Fin si mapIdExtTotal.containsKey(strCodigoModelo)

            }//Fin del for para mapIdExtTotal.get(sIdExtCod)
            
            //}//Fin si sIdExtCod == '17922020'
            
        }//Fin del for para lstModelos
        
        
        
        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.lstOrdenCompraWrapper.size(): ' + lstOrdenCompraWrapper.size());   
        return lstOrdenCompraWrapper;
    }

    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static Map<String, List<String>> getSeries(String recordId, Boolean bSolCerradaParam) {
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getSeries...');
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getSeries recordId: ' + recordId + ' bSolCerradaParam:' + bSolCerradaParam);

        //Para los datos del inventario 57000
        Id userId = UserInfo.getUserId();
        user usuario = [SELECT id,CodigoDistribuidor__c FROM user WHERE id =: userId];
        String strCodigoDistribuidor = usuario.CodigoDistribuidor__c == null ? '57000' : usuario.CodigoDistribuidor__c;
        if (Test.isRunningTest())
            strCodigoDistribuidor = '570550';
        
        Map<String, Integer> mapIdExtTotal = new Map<String, Integer>();
        Map<String, Set<String>> mapIdExtSerColExtColInt = new Map<String, Set<String>>();
        Map<String, String> mapIdExtProdSerie = new Map<String, String>();
        Set<String> setIdExterno = new Set<String>();
        
        //Obtern el estaus de la solicitud
        String sEstatus = getEstatusSol(recordId);
        Boolean bSolCerrada = sEstatus == 'Cerrada' ?  true : false; 
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getSeries bSolCerrada: ' + bSolCerrada);
        
        List<InventarioWholesale__c> listaInventarioWholesale = getInventarioPiso(strCodigoDistribuidor);
        List<Inventario_en_Transito__c> listaInventarioTransito = getInventarioTransito(strCodigoDistribuidor);
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getSeries listaInventarioWholesale: ' + listaInventarioWholesale);
        System.debug('ENTRO A TAM_SolicitudCompraInventProgramComCtrl.getSeries listaInventarioTransito: ' + listaInventarioTransito);
        
        //Recorre la lista de listaInventarioWholesale
        for (InventarioWholesale__c objInve : listaInventarioWholesale 
             ){
             //Ve si no exoste en el mapa de mapIdExtTotal entonces agregalo
             if (mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)){
                Integer intTotal = mapIdExtTotal.get(objInve.TAM_IdExterno__c);
                intTotal++;
                mapIdExtTotal.put(objInve.TAM_IdExterno__c, intTotal);      
             }//Fin si mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)
             if (!mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)){ 
                mapIdExtTotal.put(objInve.TAM_IdExterno__c, 1); 
                //System.debug('EN getDistribuidores getSeries objInve.TAM_IdExterno__c: ' + objInve.TAM_IdExterno__c + ' Toms_Series_Name__c: ' + objInve.Toms_Series_Name__c);    
             }                          
        }                                                            
        
        //Recorre la lista de listaInventarioTransito
        for (Inventario_en_Transito__c objInve : listaInventarioTransito 
             ){
             //Ve si no exoste en el mapa de mapIdExtTotal entonces agregalo
             if (mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)){
                Integer intTotal = mapIdExtTotal.get(objInve.TAM_IdExterno__c);
                intTotal++;
                mapIdExtTotal.put(objInve.TAM_IdExterno__c, intTotal);      
             }//Fin si mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)
             if (!mapIdExtTotal.containsKey(objInve.TAM_IdExterno__c)){ 
                mapIdExtTotal.put(objInve.TAM_IdExterno__c, 1); 
                //System.debug('EN getDistribuidores getSeries objInve.TAM_IdExterno__c: ' + objInve.TAM_IdExterno__c + ' Toms_Series_Name__c: ' + objInve.Toms_Series_Name__c);    
             }             
        }                                                            
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtTotal1: ' + mapIdExtTotal.keySet());
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtTotal1: ' + mapIdExtTotal.Values());     

        //Cinsulta el catalogo de prodictos para que te traigas las series reales
        for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c From Product2 p
                where IdExternoProducto__c IN : mapIdExtTotal.KeySet()]){
            //Agregalo al mapa de mapIdExtProdSerie
            mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
        }
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtProdSerie: ' + mapIdExtProdSerie.keySet());
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtProdSerie: ' + mapIdExtProdSerie.Values());      
                
        //Recorre la lista de CatalogoCentralizadoModelos__c
        List<CatalogoCentralizadoModelos__c> lstSeries = new List<CatalogoCentralizadoModelos__c>();                                                    
        for (CatalogoCentralizadoModelos__c objSeries : [SELECT Serie__c, AnioModelo__c, Modelo__c 
                FROM CatalogoCentralizadoModelos__c  ORDER BY Name]){
            lstSeries.add(objSeries);
        }                                                    

        //Ya esta cerrada
        if (bSolCerrada){
            setIdExterno.clear();
            lstSeries.clear();
            for (CatalogoCentralizadoModelos__c objSeries : [SELECT Serie__c, AnioModelo__c, Modelo__c 
                    FROM CatalogoCentralizadoModelos__c ORDER BY Name]){
                String sIdExt = objSeries.Modelo__c + '' +  objSeries.AnioModelo__c;
                System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries YA ESTA CERRADA sIdExt: ' + sIdExt + ' Serie: ' + objSeries.Serie__c);   
                setIdExterno.add(sIdExt);       
                lstSeries.add(objSeries);
            }
        }//!bSolCerrada
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries lstSeries2: ' + lstSeries);

        //Cinsulta el catalogo de prodictos para que te traigas las series reales
        for (Product2 producto :   [Select p.Serie__r.Id_Externo_Serie__c, p.Serie__c, p.IdExternoProducto__c From Product2 p
                where IdExternoProducto__c IN : setIdExterno]){
            //Agregalo al mapa de mapIdExtProdSerie
            mapIdExtProdSerie.put(producto.IdExternoProducto__c, producto.Serie__r.Id_Externo_Serie__c);
        }
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtProdSerie2: ' + mapIdExtProdSerie.keySet());
        System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries mapIdExtProdSerie2: ' + mapIdExtProdSerie.Values());     
        
        //Consulta lops vines asociados a esta solicitud
        for (TAM_VinesFlotillaPrograma__c objVinesFlotProg : [Select t.TAM_IdExterno__c 
                From TAM_VinesFlotillaPrograma__c t Where
                t.TAM_SolicitudFlotillaPrograma__c = :recordId  
                ]){
            System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries TAM_IdExterno__c: ' + objVinesFlotProg.TAM_IdExterno__c);
                                    
            //Toma el campo de TAM_IdExterno__c y destripalo
            String[] sTAMIdExterno = objVinesFlotProg.TAM_IdExterno__c.split('-');
            System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries sTAMIdExterno: ' + sTAMIdExterno + ' size(): ' + sTAMIdExterno.size());
            String sTAMIdExternoPaso = '';
            String sSerie = '';
            //Toma desde el numero 1 y 3            
            if (sTAMIdExterno.size() == 9){
                sTAMIdExternoPaso = sTAMIdExterno[4] + '' + sTAMIdExterno[1];
                sSerie = sTAMIdExterno[2] + '-' + sTAMIdExterno[3];
            }//Fin si sTAMIdExterno.size() > 7
            if (sTAMIdExterno.size() == 8){
                sTAMIdExternoPaso = sTAMIdExterno[3] + '' + sTAMIdExterno[1];
                sSerie = sTAMIdExterno[2];          
            }//Fin si sTAMIdExterno.size() <= 7
            System.debug('EN TAM_SolicitudCompraInventProgramComCtrl.getSeries sTAMIdExternoPaso: ' + sTAMIdExternoPaso + ' sSerie: ' + sSerie);

             //Ve si no exoste en el mapa de mapIdExtTotal entonces agregalo
             if (mapIdExtSerColExtColInt.containsKey(sTAMIdExternoPaso))
                mapIdExtSerColExtColInt.get(sTAMIdExternoPaso).add(sSerie);
             if (!mapIdExtSerColExtColInt.containsKey(sTAMIdExternoPaso))
                mapIdExtSerColExtColInt.put(sTAMIdExternoPaso, new Set<String>{sSerie});
        }
        System.debug('EN getDistribuidores getSeries mapIdExtSerColExtColInt: ' + mapIdExtSerColExtColInt.keySet());
        System.debug('EN getDistribuidores getSeries mapIdExtSerColExtColInt: ' + mapIdExtSerColExtColInt.Values());        

        /* Serie__c AnioModelo__c */
        List<String> lstAnioModelo;
        Map<String, Set<String>> mapModelos = new Map<String, Set<String>>();
        Map<String, List<String>> mapModelosFinal = new Map<String, List<String>>();
        
        for(CatalogoCentralizadoModelos__c objCatalogoModelo : lstSeries){
            String strCodigoModelo = objCatalogoModelo.Modelo__c + objCatalogoModelo.AnioModelo__c;
            //Ve si el strCodigoModelo existe en mapIdExtTotal
            if (mapIdExtTotal.containsKey(strCodigoModelo)){
                //Ve si el strCodigoModelo existe en mapIdExtTotal
                if (!bSolCerrada){
                    String sSerie = mapIdExtProdSerie.get(strCodigoModelo);
                    //Ya existe en el mapa de mapModelos
                    if(mapModelos.containsKey(objCatalogoModelo.AnioModelo__c))
                        mapModelos.get(objCatalogoModelo.AnioModelo__c).add(sSerie); //objCatalogoModelo.Serie__c
                    if(!mapModelos.containsKey(objCatalogoModelo.AnioModelo__c))
                        mapModelos.put(objCatalogoModelo.AnioModelo__c, new Set<String>{sSerie}); //objCatalogoModelo.Serie__c
                }//Fin si !bSolCerrada*/
                if (bSolCerrada){
                    //ve si existe en el mapa de 
                    if (mapIdExtSerColExtColInt.containsKey(strCodigoModelo)){
                        String sSerie = mapIdExtProdSerie.get(strCodigoModelo);
                        System.debug('EN getDistribuidores getSeries sSerie: ' + sSerie);
                        if (mapIdExtSerColExtColInt.get(strCodigoModelo).contains(sSerie)){ //objCatalogoModelo.Serie__c
                            //Ya existe en el mapa de mapModelos
                            if(mapModelos.containsKey(objCatalogoModelo.AnioModelo__c))
                                mapModelos.get(objCatalogoModelo.AnioModelo__c).add(sSerie); //objCatalogoModelo.Serie__c
                            if(!mapModelos.containsKey(objCatalogoModelo.AnioModelo__c))
                                mapModelos.put(objCatalogoModelo.AnioModelo__c, new Set<String>{sSerie}); //objCatalogoModelo.Serie__c
                        }//Fin si mapIdExtSerColExtColInt.get(strCodigoModelo).containsKey(objCatalogoModelo.Serie__c)
                    }//fin si mapIdExtSerColExtColInt.containsKey(strCodigoModelo)
                }//Fin si !bSolCerrada                                              
            }//Fin si mapIdExtTotal.containsKey(strCodigoModelo)
        }//Fin del for para  CatalogoCentralizadoModelos__c
        
        //Recorre el mapa de mapModelos y crea el mapa final de mapModelosFinal
        for (String sModYear : mapModelos.keySet()){
            List<String> lPasoMod = new List<String>(); 
            lPasoMod.addAll(mapModelos.get(sModYear));
            System.debug('EN getDistribuidores getSeries objCatalogoModelo sModYear: ' + sModYear);
            System.debug('EN getDistribuidores getSeries objCatalogoModelo lPasoMod: ' + lPasoMod);
            mapModelosFinal.put(sModYear, lPasoMod);
        }
        
        System.debug('EN A TAM_SolicitudCompraInventProgramComCtrl.getSeries mapModelosFinal: ' + mapModelosFinal);
        return mapModelosFinal;
    }

    //Obtener distribuidores.
    @AuraEnabled
    public static string getTipRegPrograma(String strTipRegNombre) {
        System.debug('EN getTipRegPrograma strTipRegNombre: ' + strTipRegNombre);
        
        String sRectorTypePasoPrograma = '';
        if (strTipRegNombre != null && strTipRegNombre != '')
            sRectorTypePasoPrograma = Schema.SObjectType.TAM_DistribuidoresFlotillaPrograma__c.getRecordTypeInfosByName().get(strTipRegNombre).getRecordTypeId();
        
        System.debug('EN getDistribuidores sRectorTypePasoPrograma: ' + sRectorTypePasoPrograma);
        return sRectorTypePasoPrograma;
    }   
    
    public static Map<String,Double>  ObtenerPrecios(){

         //Obtiene mes y año para buscar la lista de precios correspondiente.
        Date fechaActual = System.today();
        String strAnio = String.valueOf(fechaActual.year());
        Integer intMesActual = fechaActual.month();
        Map<Integer,String> mapMes = new Map<Integer,String>();
        mapMes.put(1, 'ENERO');
        mapMes.put(2, 'FEBRERO');
        mapMes.put(3, 'MARZO');
        mapMes.put(4, 'ABRIL');
        mapMes.put(5, 'MAYO');
        mapMes.put(6, 'JUNIO');
        mapMes.put(7, 'JULIO');
        mapMes.put(8, 'AGOSTO');
        mapMes.put(9, 'SEPTIEMBRE');
        mapMes.put(10, 'OCTUBRE');
        mapMes.put(11, 'NOVIEMBRE');
        mapMes.put(12, 'DICIEMBRE');

        String strMes = mapMes.get(intMesActual);
        String strNombreCatalogoPrecios = 'VH-' + strMes + '-' + strAnio;

        System.debug('**** CODIGO PRECIO******* ' + strNombreCatalogoPrecios);

        //Mapa de catálogo de lista de precios.
        List<PricebookEntry> lstCatalogoPrecios = [ SELECT  Id,
                                                            ProductCode,
                                                            PrecioSinIva__c
                                                    FROM    PricebookEntry
                                                    WHERE   IsActive = true AND Pricebook2.Name =:strNombreCatalogoPrecios
        ];
        System.debug('**** TAMAÑO LISTA PRICEBOOK ******* ' + lstCatalogoPrecios.size());

        String strCodigoProducto;
        Double dblPrecioSinIVA;
        Map<String,Double> mapPriceBookEntry = new Map<String,Double>();
        for(PricebookEntry objListaPrecio : lstCatalogoPrecios){
            strCodigoProducto = objListaPrecio.ProductCode;
            dblPrecioSinIVA = objListaPrecio.PrecioSinIva__c;
            mapPriceBookEntry.put(strCodigoProducto, dblPrecioSinIVA);
        }
        return mapPriceBookEntry;
    }
        
    //Obtener distribuidores.
    @AuraEnabled
    public static Map<String, Integer> getSolDistrib(String recordId) {
        System.debug('EN getSolDistrib recordId: ' + recordId);
        String sRectorTypePasoPrograma = '';
        Map<String, Integer> mapIdExtrCantidad = new Map<String, Integer>();
        
        //Ve al objeto de TAM_DistribuidoresFlotillaPrograma__c en base al recordId de la solicitud
        //Ya tienes la llave consulta los datos en TAM_DistribuidoresFlotillaPrograma__c
        for (TAM_DistribuidoresFlotillaPrograma__c objDistrib : [Select ID, TAM_Cantidad__c, TAM_IdExterno__c
            From TAM_DistribuidoresFlotillaPrograma__c  Where
                TAM_SolicitudFlotillaPrograma__c = :recordId   
                //TAM_SolicitudCompraPROGRAMA__c =:recordId 
                And TAM_IdExterno__c != null]){
                //Toma la el ID externo y cortalo hasta el ultimo  -
                String sIdExternoPaso = objDistrib.TAM_IdExterno__c;
                System.debug('EN getSolDistrib sIdExternoPaso: ' + sIdExternoPaso);
                sIdExternoPaso = sIdExternoPaso.substring(0, sIdExternoPaso.lastIndexOf('-'));
                //System.debug('EN getSolDistrib sIdExternoPaso: ' + sIdExternoPaso);
                String sIdExternoPaso2 = sIdExternoPaso.substring(0, sIdExternoPaso.lastIndexOf('-'));
                //System.debug('EN getSolDistrib sIdExternoPaso2: ' + sIdExternoPaso2);
                //Ahora si agregalo al mapa de mapIdExtrCantidad
                if (mapIdExtrCantidad.containsKey(sIdExternoPaso2)){
                    Integer intCanti = mapIdExtrCantidad.get(sIdExternoPaso2) + Integer.valueOf(objDistrib.TAM_Cantidad__c);
                    mapIdExtrCantidad.put(sIdExternoPaso2, intCanti);
                }//Fin si mapIdExtrCantidad.containsKey(sIdExternoPaso2)
                //No existe la clave 
                if (!mapIdExtrCantidad.containsKey(sIdExternoPaso2))
                    mapIdExtrCantidad.put(sIdExternoPaso2, Integer.valueOf(objDistrib.TAM_Cantidad__c));
        }//fin del for para TAM_DistribuidoresFlotillaPrograma__c
        
        System.debug('EN getDistribuidores mapIdExtrCantidad: ' + mapIdExtrCantidad.keySet());
        System.debug('EN getDistribuidores mapIdExtrCantidad: ' + mapIdExtrCantidad.Values());
        
        //Regresa el mapa con oos datos
        return mapIdExtrCantidad;
    }   

    //Obtener distribuidores.
    @AuraEnabled
    public static Map<String, Boolean> getEntregaDistribuidora(String recordId, String sRectTyoeId) {
        System.debug('EN getEntregaDistribuidora recordId: ' + recordId + ' sRectTyoeId: ' + sRectTyoeId);
        String sRectorTypePasoPrograma = '';
        Map<String, Boolean> mapIdExtrEntregaDistrib = new Map<String, Boolean>();
        
        //Ve al objeto de TAM_DistribuidoresFlotillaPrograma__c en base al recordId de la solicitud
        //Ya tienes la llave consulta los datos en TAM_DistribuidoresFlotillaPrograma__c
        for (TAM_DetalleOrdenCompra__c objTAMDetalleOrdenCompra : [Select TAM_IdExterno__c, TAM_EntregarEnMiDistribuidora__c 
            From TAM_DetalleOrdenCompra__c Where
            TAM_SolicitudFlotillaPrograma__c = :recordId   
            //TAM_SolicitudCompraPROGRAMA__c = :recordId 
            And RecordTypeId =: sRectTyoeId ]){
                //Toma la el ID externo y cortalo hasta el ultimo  -
                String sIdExternoPaso = objTAMDetalleOrdenCompra.TAM_IdExterno__c;
                System.debug('EN getEntregaDistribuidora sIdExternoPaso: ' + sIdExternoPaso);
                sIdExternoPaso = sIdExternoPaso.substring(0, sIdExternoPaso.lastIndexOf('-'));
                //System.debug('EN getSolDistrib sIdExternoPaso: ' + sIdExternoPaso);
                String sIdExternoPaso2 = sIdExternoPaso.substring(0, sIdExternoPaso.lastIndexOf('-'));
                //System.debug('EN getSolDistrib sIdExternoPaso2: ' + sIdExternoPaso2);
                //Ahora si agregalo al mapa de mapIdExtrEntregaDistrib
                //No existe la clave 
                if (!mapIdExtrEntregaDistrib.containsKey(sIdExternoPaso2))
                    mapIdExtrEntregaDistrib.put(sIdExternoPaso2, Boolean.valueOf(objTAMDetalleOrdenCompra.TAM_EntregarEnMiDistribuidora__c));           
        }
                
        //System.debug('EN getDistribuidores mapIdExtrEntregaDistrib: ' + mapIdExtrEntregaDistrib.keySet());
        //System.debug('EN getDistribuidores mapIdExtrEntregaDistrib: ' + mapIdExtrEntregaDistrib.Values());
        
        //Regresa el mapa con oos datos
        return mapIdExtrEntregaDistrib;
    }   
    
    //Obtener distribuidores.
    @AuraEnabled
    public static string getEstatusSol(String recordId) {
        System.debug('EN getEstatusSol recordId: ' + recordId);
        
        String sEstatusSol = '';        
        List<TAM_SolicitudesFlotillaPrograma__c> solicitud = [Select t.TAM_Estatus__c, t.Name, t.Id 
                From TAM_SolicitudesFlotillaPrograma__c t
                WHERE id =: recordId];
        sEstatusSol = solicitud[0].TAM_Estatus__c;                      
        
        System.debug('EN getEstatusSol sEstatusSol: ' + sEstatusSol);
        return sEstatusSol;
    }    
    
    //Obtener distribuidores.
    @AuraEnabled
    public static string getTipoRegSol(String recordId) {
        System.debug('EN getEstatusSol recordId: ' + recordId);
        
        String sRecordTypeId = '';      
        List<TAM_SolicitudesFlotillaPrograma__c> solicitud = [Select t.RecordTypeId 
                From TAM_SolicitudesFlotillaPrograma__c t
                WHERE id =: recordId];           
        sRecordTypeId = solicitud[0].RecordTypeId;                      
        
        System.debug('EN getEstatusSol sRecordTypeId: ' + sRecordTypeId);
        return sRecordTypeId;

    }
    
}